ProtobufRegion (Apache Geode 1.5.0)
Date: 2018-03-30

org.apache.geode.experimental.driver

## Class ProtobufRegion<K,V>

- java.lang.Object
- - org.apache.geode.experimental.driver.ProtobufRegion<K,V>

- Type Parameters:
    `K` - Type of region keys.
    `V` - Type of region values.
  All Implemented Interfaces:
    Region<K,V>

      @Experimental
      public class ProtobufRegion<K,V>
      extends java.lang.Object
      implements Region<K,V>

  Implements the behaviors of a GemFire region. Send and receives Protobuf messages on the provided socket to communicate with a GemFire server that has Protobuf enabled. This code is an experimental prototype and is presented "as is" with no warranty, suitability, or fitness of purpose implied.

- - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `V` | `get(K key)` Gets the value, if any, contained in this region for the `key`.
    `java.util.Map<K,V>` | `getAll(java.util.Collection<K> keys)` Gets the values, if any, contained in this region for the collection of `keys`.
    `RegionAttributes` | `getRegionAttributes()` Captures a snapshot of the attributes (e.g., size) of this region.
    `java.util.Set<K>` | `keySet()` Gets all the keys for which this region has entries
    `void` | `put(K key, V value)` Puts the `value` into this region for the `key`.
    `void` | `putAll(java.util.Map<K,V> values)` Puts the map from keys to `values` into this region.
    `void` | `remove(K key)` Removes any value associated with the `key` from this region.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### getRegionAttributes

          public RegionAttributes getRegionAttributes()
                                               throws java.io.IOException

      Description copied from interface: `Region`
      Captures a snapshot of the attributes (e.g., size) of this region.
      Specified by:
        `getRegionAttributes` in interface `Region<K,V>`
      Returns:
        Attributes associated with this region.
      Throws:
        `java.io.IOException`

    - #### get

          public V get(K key)
                throws java.io.IOException

      Description copied from interface: `Region`
      Gets the value, if any, contained in this region for the `key`.
      Specified by:
        `get` in interface `Region<K,V>`
      Parameters:
        `key` - Unique key associated with a value.
      Returns:
        Value, if any, associated with `key`.
      Throws:
        `java.io.IOException`

    - #### getAll

          public java.util.Map<K,V> getAll(java.util.Collection<K> keys)
                                    throws java.io.IOException

      Description copied from interface: `Region`
      Gets the values, if any, contained in this region for the collection of `keys`.
      Specified by:
        `getAll` in interface `Region<K,V>`
      Parameters:
        `keys` - Collection of unique keys associated with values.
      Returns:
        Map from `keys` to their associated values.
      Throws:
        `java.io.IOException`

    - #### put

          public void put(K key,
                          V value)
                   throws java.io.IOException

      Description copied from interface: `Region`
      Puts the `value` into this region for the `key`.
      Specified by:
        `put` in interface `Region<K,V>`
      Parameters:
        `key` - Unique key to associate with the `value`.
        `value` - Value to associate with the `key`.
      Throws:
        `java.io.IOException`

    - #### putAll

          public void putAll(java.util.Map<K,V> values)
                      throws java.io.IOException

      Description copied from interface: `Region`
      Puts the map from keys to `values` into this region. If any one key/value pair can not be inserted, the remaining pair insertions will be attempted.
      Specified by:
        `putAll` in interface `Region<K,V>`
      Parameters:
        `values` - Map from `keys` to their associated values.
      Throws:
        `java.io.IOException`

    - #### remove

          public void remove(K key)
                      throws java.io.IOException

      Description copied from interface: `Region`
      Removes any value associated with the `key` from this region.
      Specified by:
        `remove` in interface `Region<K,V>`
      Parameters:
        `key` - Unique key associated with a value.
      Throws:
        `java.io.IOException`

    - #### keySet

          public java.util.Set<K> keySet()
                                  throws java.io.IOException

      Description copied from interface: `Region`
      Gets all the keys for which this region has entries
      Specified by:
        `keySet` in interface `Region<K,V>`
      Returns:
        Set of keys in this region
      Throws:
        `java.io.IOException`